#include "ambiente.h"

double Ambiente::PressVaporAgua(double temperatura)
{
	temperatura += 273.15;
	return(exp(-5.8002206e3/temperatura 
				+1.3914993
				-4.8640239e-2*temperatura
				+4.1764768e-5*pow(temperatura,2.0)
				-1.4452093e-8*pow(temperatura,3.0)
				+6.5459673*log(temperatura)));
}

double Ambiente::EntalpiaVapAgua(double tempAr)
{
	return (2500.89 - 2.3736*tempAr)*1000.0;
}
	
double Ambiente::CalorEspAr(double tempAr)
{
	double cteAr = 287.055;
	return (3.355 + 0.575e-3*pow(tempAr+273.15,2.0) 
			- 0.016e5*pow(tempAr+273.15,-5.0))*cteAr;
}

double Ambiente::UmidadeAbs(double tempAr, double umidRel, double pBar)
{
	double pressVapAgua = PressVaporAgua(tempAr);
	return 0.62198*umidRel*pressVapAgua/(pBar-umidRel*pressVapAgua);
}

double Ambiente::DensidadeAr(double tempAr, double pBar)
{
	double cteAr = 287.055;
	return pBar/(cteAr*(tempAr+273.15));
}

