#ifndef PONTOH
#define PONTOH

#include "definicao.h"

/*****************************************************************
Classe: 	Ponto
Descricao: 	Definicao de um ponto com 1, 2 ou 3 dimensoes.
Arquivo: 	Ponto.h
Autor: 		Cyro Albuquerque Neto
Criacao: 	18/08/2008
Revisao: 	18/08/2008
******************************************************************/

template <typename T> class Ponto {
	T coord1, coord2, coord3;
public:
	//Contrutor
	Ponto() {}
	Ponto(T val1) : coord1(val1) {}
	Ponto(T val1, T val2) : coord1(val1), coord2(val2) {}
	Ponto(T val1, T val2, T val3) : 
		coord1(val1), coord2(val2), coord3(val3) {}
	//Ponto
	T C1() const { return coord1; }
	void SetC1(T valor) { coord1=valor; }
	T C2() const { return coord2; }
	void SetC2(T valor) { coord2=valor; }
	T C3() const { return coord3; }
	T PtCoord(IntPos k) const { 
		if (k==0) return coord1; 
		else if (k==1) return coord2; 
		else /*if (k==2)*/ return coord3; 
	}
	T PtCoord(Direcao k) const { 
		if (k==WE) return coord1; 
		else if (k==SN) return coord2; 
		else /*if (k==FB)*/ return coord3; 
	}
	void SetC3(T valor) { coord3=valor; }
	void SetPonto(T v1) { coord1=v1; }
	void SetPonto(T v1, T v2) { coord1=v1; coord2=v2; }
	void SetPonto(T v1, T v2, T v3) 
		{ coord1=v1; coord2=v2; coord3=v3; }
	void SetPtCoord(IntPos k, T val) {
		if (k==0) coord1=val;
		else if (k==1) coord2=val;
		else /*if (k==2)*/ coord3=val;
	}
	void SetPtCoord(Direcao k, T val) {
		if (k==WE) coord1=val;
		else if (k==SN) coord2=val;
		else if (k==FB) coord3=val;
	}
};

#endif
